unit ICQPager;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,WinInet, Psock;

type
  Ticqpager = class(TComponent)
  private
    PURL, Pfrom, Pfromemail, Psubject,Pbody, Ptoicqnumber : string;
    psent : boolean;
    { Private declarations }
  protected
    { Protected declarations }
  public
    constructor Create(AOwner : TComponent); override;
    procedure SendPager;
    procedure GenerateURL;
    property URL:string read PURL write PURL;
    property Sent:boolean read Psent write Psent;
    { Public declarations }
  published
    property From:string read Pfrom write Pfrom;
    property Fromemail:string read PfROMeMAIL write PFromemail;
    property Subject : string read Psubject write Psubject;
    property Body : string read Pbody write Pbody ;
    property ToICQnumber : string read Ptoicqnumber write Ptoicqnumber;
    { Published declarations }
  end;

procedure Register;

implementation

constructor TICQPager.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 PFrom := 'Anonymous';
end;


procedure TICQPager.GenerateURL;
begin
PUrl := 'http://wwp.icq.com/scripts/WWPMsg.dll?from=' + PFrom + '&fromemail=' + Pfromemail + '&subject=' + Psubject + '&body=' +  Pbody + '&to=' + Ptoicqnumber + '&submit=send';
end;

procedure TICQPager.SendPager;
const
 TamMax = 1024;
var
 Buffer: array [0..TamMax - 1] of Char;
 nRead , nTimeOut : DWORD;
 strRead: string;
 hHttpSession, hReqUrl: HInternet;
 StrURL : String ; TimeOut : LongWord; 
begin
PUrl := 'http://wwp.icq.com/scripts/WWPMsg.dll?from=' + PFrom + '&fromemail=' + Pfromemail + '&subject=' + Psubject + '&body=' +  Pbody + '&to=' + Ptoicqnumber + '&submit=send';
StrURL := PUrl;

 strRead := '';
 hHttpSession := InternetOpen ('GetURL', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, INTERNET_FLAG_NO_CACHE_WRITE );
 InternetQueryOption(hHttpSession , INTERNET_OPTION_CONNECT_TIMEOUT , @nTimeOut , nRead);
 nTimeOut := TimeOut ;
 InternetSetOption(hHttpSession , INTERNET_OPTION_CONNECT_TIMEOUT , @nTimeOut , nRead);

 try
   hReqUrl := InternetOpenURL (hHttpSession, PChar(StrUrl), nil, 0,0,0);
   try
     repeat
       FillChar(Buffer , SizeOf(Buffer) , #0);
       InternetReadFile (hReqUrl, @Buffer, sizeof(Buffer), nRead);
       strRead := strRead + string (Buffer);
     until nRead < TamMax;
   finally
     InternetCloseHandle (hReqUrl);
   end;
 finally
   InternetCloseHandle (hHttpSession);

 end;
end;

procedure Register;
begin
  RegisterComponents('Custom', [Ticqpager]);

end;

end.
 